<?php 
/*
Plugin Name: WP Get Personal Lite
Plugin URI: http://www.stevenhenty.com/wpgetpersonal-lite
Description: Allows you to personalize your pages simply by adding the name to the end of the URL.
Author: Steven Henty
Version: 1.0
Author URI: http://www.stevenhenty.com

------------------------------------------------------------------------
Copyright 2011 Steven Henty

*/


function wpgetpersonal_init_method() {

	global $wp_query;
	if (!$wp_query->is_404){
		return;
	}	

	$wpgetpersonal_request_url = $_SERVER['REQUEST_URI'];   
	$wpgetpersonal_complete_url = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
	$wpgetpersonal_wpurl = get_bloginfo('url')."/"; 
	

	$wpgetpersonal_epos = strpos($wpgetpersonal_complete_url, get_admin_url());
	if ($wpgetpersonal_epos) {
	return;
	}
	

	$wpgetpersonal_params_strpos = strpos($wpgetpersonal_request_url, "?");

	$wpgetpersonal_params = '';  
	if ($wpgetpersonal_params_strpos !== false){
		
		$wpgetpersonal_params = substr($wpgetpersonal_request_url, $wpgetpersonal_params_strpos);
		$wpgetpersonal_request_url = substr( $wpgetpersonal_request_url , 0 , $wpgetpersonal_params_strpos);
	}

	$wpgetpersonal_wpgp_strpos = strpos($wpgetpersonal_params, "wpgp=");
	if ($wpgetpersonal_wpgp_strpos !== false) {
	return;
	}
	
	$wpgetpersonal_url_array = explode("/",$wpgetpersonal_request_url);
	
	$totalarr = count($wpgetpersonal_url_array); 
	if (empty($wpgetpersonal_url_array[$totalarr-1])) {
		$totalarr -= 1;
	}
														
	$wpgetpersonal_contactinfo = $wpgetpersonal_url_array[$totalarr-1];
	$wpgetpersonal_pagename = $wpgetpersonal_url_array[$totalarr-2];
	
	if ($wpgetpersonal_contactinfo == "") {
	return;
	}
	
	$wpgetpersonal_contactinfo_strpos = strpos($wpgetpersonal_complete_url, $wpgetpersonal_contactinfo);
	$wpgetpersonal_first_part = substr( $wpgetpersonal_complete_url , 0 , $wpgetpersonal_contactinfo_strpos);
	if ($wpgetpersonal_first_part == $wpgetpersonal_wpurl) {
		return;
	}
	else {
		$wpgetpersonal_pagename_strpos = strpos($wpgetpersonal_complete_url, $wpgetpersonal_pagename);
		
		$wpgetpersonal_base_url = substr( $wpgetpersonal_complete_url , 0 , $wpgetpersonal_pagename_strpos);
		
		
		global $wpdb;
		
		$page_id = $wpdb->get_var($wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE (post_type = 'page') AND post_name = '$wpgetpersonal_pagename' AND post_status = 'publish'"));
		
		$wpgetpersonal_meta_value = get_post_meta($page_id, 'wpgetpersonal' , true);
				
		

		$wpgetpersonal_pagename = $wpgetpersonal_pagename . "/";
		
		if( empty($page_id) ) {
		return;
		}
		
		if(empty($wpgetpersonal_meta_value)) {
		return;
		}
	}
		
	
	
	status_header( 200 );
	$wp_query->is_404 = false;
	
	if ($wpgetpersonal_params == ""){
		$wpgetpersonal_params = "?";
	}
	else {
		$wpgetpersonal_params = $wpgetpersonal_params . "&";
	}
	
	$blog_URL = $wpgetpersonal_base_url . $wpgetpersonal_pagename . $wpgetpersonal_params . "wpgp=" . $wpgetpersonal_contactinfo ;   
	
	if (!empty($_COOKIE)) 
	{
		$cookies = array_implode("=",";", $_COOKIE);

		$headers = array( 'cookie' => $cookies );
			
		$response = wp_remote_get($blog_URL, array( 'headers' => $headers ));
	}
	else 
	{
		$response = wp_remote_get($blog_URL);
	}
	
	echo ( $response['body'] );

	die; 
	
}    
function array_implode( $glue, $separator, $array ) {
    if ( ! is_array( $array ) ) return $array;
    $string = array();
    foreach ( $array as $key => $val ) {
        if ( is_array( $val ) )
            $val = implode( ',', $val );
        $string[] = "{$key}{$glue}{$val}";
       
    }
    return implode( $separator, $string );
   
}

add_action('wp', 'wpgetpersonal_init_method');
add_action('add_meta_boxes', 'wpgetpersonal_add_custom_box');
add_action('save_post', 'wpgetpersonal_save_postdata');

function wpgetpersonal_add_custom_box() {
    
    add_meta_box( 'wpgetpersonal_sectionid', __( 'WP Get Personal - Lite', 'wpgetpersonal_textdomain' ), 
                'wpgetpersonal_inner_custom_box', 'page','side' );

}

function wpgetpersonal_inner_custom_box( $post ) {

   wp_nonce_field( plugin_basename(__FILE__), 'wpgetpersonal_noncename' );
   $checked = "";
   
   if($_GET['action'] == 'edit'){
	   $postid = $_GET['post'];
	   
	   
	   $wpgetpersonal_meta_value = array();
	   $wpgetpersonal_meta_value = get_post_meta($postid, 'wpgetpersonal' , true);
	   if(!empty($wpgetpersonal_meta_value) == 1){
	   
			if ($wpgetpersonal_meta_value['wpgetpersonal_activated'] == '1') {
	       $checked = "checked='yes'";
		   }
	   }
	   else{
	       $checked = "";
	   }
   }
   

   echo '<label for="wpgetpersonal_activated">' . __("Activate virtual urls", 'wpgetpersonal_textdomain' ) . '</label> ';
   echo '<input type="checkbox" id= "wpgetpersonal_activated" name="wpgetpersonal_activated" value="1"  ' . $checked . '/>';
    echo '<br /><br />Shortcode: [wpgetpersonal]';
}


function wpgetpersonal_save_postdata( $post_id ) {

  if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
      return;
 
	  if ( !wp_verify_nonce( $_POST['wpgetpersonal_noncename'], plugin_basename(__FILE__) )) {
		return;
	  }

	 if ( 'page' == $_POST['post_type'] ) {
		if ( !current_user_can( 'edit_page', $post_id ) )
		  return;
	  } else {
		if ( !current_user_can( 'edit_post', $post_id ) )
		  return;
	  }
	 
	 if($_POST['wpgetpersonal_activated'] == ""	){
	  	$_POST['wpgetpersonal_activated'] = 0; 
	 }
	 	
	 $data  = array();
	 $data['post_id'] = $post_id;
	 $data['wpgetpersonal'] = $_POST['wpgetpersonal_activated'];
	

	$wpgetpersonal_meta_value = get_post_meta($post_id, 'wpgetpersonal' , true);
	if ( empty( $wpgetpersonal_meta_value ) && ( $data['wpgetpersonal'] = "1" )) {
	
		$wpgetpersonal_options = array();
		$wpgetpersonal_options['wpgetpersonal_activated'] = '1';
		 add_post_meta( $post_id, 'wpgetpersonal', $wpgetpersonal_options, true);
	}
	elseif ('' == $data['wpgetpersonal'] && $wpgetpersonal_meta_value) {
		delete_post_meta( $post_id, 'wpgetpersonal');
	}
	
  
}

function wpgetpersonal_shortcode( $atts, $content = null ) {
	
	extract( shortcode_atts( array(
					'fallback' => 'Friend',
	), $atts ) );
	
	$wpqueryvar = get_query_var('wpgp');
	

	if(isset($_REQUEST['wpgp']) AND $_REQUEST['wpgp'] != '')
	  {
			$wpgetpersonal_shortcode_val = $_REQUEST['wpgp']; 
	  }
	  else
	  {
			$wpgetpersonal_shortcode_val = $fallback; 
	  }

	  
	  return $wpgetpersonal_shortcode_val;
}


add_shortcode( 'wpgetpersonal', 'wpgetpersonal_shortcode' );



  


  



?>
